#include <windows.h>
#include <map>
#include <vector>

// tbN\
typedef struct
{  
	HWND hWnd;
	int Scale;
	BOOL MessageHook;
    BOOL SetCursorPosHook;
    BOOL GetCursorPosHook;
    BOOL MoveWindowHook;
    BOOL SetWindowPosHook;
    BOOL ClipCursolHook; 
	BOOL ScreenShotHook;
}HOOK_INFO;

// API ̃IWiAhX
FARPROC g_pGetCursorPos = NULL;
FARPROC g_pSetCursorPos = NULL;
FARPROC g_pMoveWindow = NULL;
FARPROC g_pSetWindowPos = NULL;
FARPROC g_pClipCursor = NULL;
FARPROC g_pGetDC = NULL;
FARPROC g_pReleaseDC = NULL;
FARPROC g_pBitBlt = NULL;

// API ̃IWiR[h
BYTE g_GetCursorPosCode[5];
BYTE g_SetCursorPosCode[5];
BYTE g_MoveWindowCode[5];
BYTE g_SetWindowPosCode[5];
BYTE g_ClipCursorCode[5];
BYTE g_GetDCCode[5];
BYTE g_ReleaseDCCode[5];
BYTE g_BitBltCode[5];

// {̃EBhEvV[W
WNDPROC OriginalProc = NULL;	

// qEBhẼvV[W
std::map<HWND, WNDPROC> g_Procs;

// foCXReLXgnh
std::vector<HDC> g_hDC;

// tbN̏
HOOK_INFO g_Info;

// EBhEnh
HWND g_hWnd = 0;


BOOL Hook(FARPROC APIAddress, LPVOID HookProc)
{
	DWORD Write,Buf1,Buf2;
	Buf1 = 0xE9;
	Buf2 = (DWORD)HookProc - (DWORD)APIAddress - 5; 

	if (WriteProcessMemory(GetCurrentProcess(),  APIAddress, &Buf1, 1, &Write) == 0)
	{
		return FALSE;
	}

	if (WriteProcessMemory( GetCurrentProcess(), (LPVOID)((DWORD)(APIAddress)+1), &Buf2, 4, &Write) == 0)
	{
		return FALSE;
	}

	return TRUE;
}

__declspec(naked)
DWORD GetEIP()
{
	_asm
	{
		MOV EAX, [ESP]
		RET
	}
}


BOOL WINAPI HkGetCursorPos(LPPOINT lpPoint)
{
	BOOL Result;

	__asm
	{
		PUSH lpPoint
		MOV ECX, g_pGetCursorPos
		ADD ECX, 5
		PUSH RetLabel
		PUSH EBP
		MOV EBP, ESP
		JMP ECX					
		RetLabel:
		MOV Result, EAX
	}

	if (lpPoint && Result)
	{
		POINT Pos;

		Pos.x = lpPoint->x;
		Pos.y = lpPoint->y;

		ScreenToClient(g_hWnd, &Pos);

		Pos.x = Pos.x * 100 / g_Info.Scale;
		Pos.y = Pos.y * 100 / g_Info.Scale;

		ClientToScreen(g_hWnd, &Pos);

		lpPoint->x = Pos.x;
		lpPoint->y = Pos.y;
	}
}

BOOL WINAPI HkSetCursorPos(int x, int y)
{
	BOOL Result;

	POINT Pos;

	Pos.x = x;
	Pos.y = y;

	ScreenToClient(g_hWnd, &Pos);

	Pos.x = Pos.x * g_Info.Scale / 100;
	Pos.y = Pos.y * g_Info.Scale / 100;

	ClientToScreen(g_hWnd, &Pos);

	x = Pos.x;
	y = Pos.y;

	__asm
	{
		PUSH y
		PUSH x
		MOV ECX, g_pSetCursorPos
		ADD ECX, 5
		PUSH RetLabel
		PUSH EBP
		MOV EBP, ESP
		JMP ECX						
		RetLabel:
		MOV Result, EAX
	}
}

__declspec (naked)
BOOL WINAPI HkMoveWindow(HWND hWnd, int x, int y, int nWidth, int nHeight, BOOL bRepaint)
{
	__asm
	{	MOV EAX, [ESP + 4]
		CMP EAX, g_hWnd
		JNE Label1
		MOV EAX, 1
		RETN 0x18
		Label1:
	}

	_asm
	{
		MOV ECX, OFFSET g_MoveWindowCode[1]		
		MOV EAX, DWORD PTR [ECX]			// NtKernelɓnVXeT[rX̃CfbNX
		MOV ECX, g_pMoveWindow
		ADD ECX, 5
		JMP ECX
	}
}

__declspec (naked)
BOOL WINAPI HkSetWindowPos(HWND hWnd, HWND hWndInsertAfter, int x, int y, int cx, int cy, UINT uFlags)
{
	__asm
	{	MOV EAX, [ESP + 4]
		CMP EAX, g_hWnd
		JNE Label1
		MOV EAX, 1
		RETN 0x1C
		Label1:
	}


	_asm
	{
		MOV ECX, OFFSET g_SetWindowPosCode[1]		
		MOV EAX, DWORD PTR [ECX]			// NtKernelɓnVXeT[rX̃CfbNX
		MOV ECX, g_pSetWindowPos
		ADD ECX, 5
		JMP ECX
	}
}


BOOL WINAPI HkClipCursor(RECT *lpRect)
{
	BOOL Result;

	POINT Pos;

	if (lpRect)
	{
		Pos.x = lpRect->right;
		Pos.y = lpRect->bottom;

		ScreenToClient(g_hWnd, &Pos);

		Pos.x = Pos.x * g_Info.Scale / 100;
		Pos.y = Pos.y * g_Info.Scale / 100;

		ClientToScreen(g_hWnd, &Pos);

		lpRect->right = Pos.x;
		lpRect->bottom  = Pos.y;
	}

	__asm
	{
		PUSH lpRect
		PUSH RetLabel
		MOV ECX, OFFSET g_ClipCursorCode[1]		
		MOV EAX, DWORD PTR [ECX]			// NtKernelɓnVXeT[rX̃CfbNX
		MOV ECX, g_pClipCursor
		ADD ECX, 5
		JMP ECX								
		RetLabel:
		MOV Result, EAX
	}
}

// tbNvV[W
LRESULT CALLBACK HookProc(HWND hWnd , UINT Msg , WPARAM WParam , LPARAM LParam)
{
	POINT Pos;

	switch (Msg)
	{
		case WM_MOUSEMOVE:
		case WM_LBUTTONDBLCLK:
		case WM_LBUTTONDOWN:
		case WM_LBUTTONUP:
		case WM_MBUTTONDBLCLK:
		case WM_MBUTTONDOWN:
		case WM_MBUTTONUP:
		case WM_RBUTTONDBLCLK:
		case WM_RBUTTONDOWN:
		case WM_RBUTTONUP:
			Pos.x = LParam & 0xFFFF; 
			Pos.y = (LParam & 0xFFFF0000) >> 16; 

			Pos.x = Pos.x * 100 / g_Info.Scale;
			Pos.y = Pos.y * 100 / g_Info.Scale;

			LParam = Pos.x | (Pos.y << 16);
	}

	return CallWindowProc(OriginalProc , hWnd, Msg, WParam, LParam);
}

HDC WINAPI HkGetDC(HWND hWnd)
{
	HDC hDC;

	_asm
	{
		PUSH hWnd
		PUSH RetLabel
		MOV ECX, OFFSET g_GetDCCode[1]		
		MOV EAX, DWORD PTR [ECX]			// NtKernelɓnVXeT[rX̃CfbNX
		MOV ECX, g_pGetDC
		ADD ECX, 5
		JMP ECX								
		RetLabel:
		MOV hDC, EAX
	}

	if (hDC)
	{
		HWND hDesktop = GetDesktopWindow();
		if ( (hWnd == NULL) || (hWnd == hDesktop) )
		{
			g_hDC.push_back(hDC);
		}
	}

	return hDC;
}


BOOL WINAPI HkReleaseDC(HWND hWnd, HDC hDC)
{
	BOOL Result;

	_asm
	{
		PUSH hDC
		PUSH hWnd
		MOV ECX, g_pReleaseDC
		ADD ECX, 5
		PUSH RetLabel
		PUSH EBP
		MOV EBP, ESP
		JMP ECX						
		RetLabel:
		MOV Result, EAX
	}

	if (Result)
	{
		for (std::vector<HDC>::iterator it = g_hDC.begin(); it != g_hDC.end(); it++)
		{
			if (*it == hDC)
			{
				g_hDC.erase(it);
				break;
			}
		}
	}

	return Result;
}


BOOL WINAPI HkBitBlt(HDC hdcDest, int nXDest, int nYDest, int nWidth, int nHeight,
  HDC hdcSrc, int nXSrc, int nYSrc, DWORD dwRop)
{
	BOOL Result;

	for (unsigned int i = 0; i < g_hDC.size(); i++)
	{
		// \[XDCfXNgbvꍇAQ[̃EBhEDC`悷
		if (hdcSrc == g_hDC[i])
		{
			HDC hDC = GetDC(g_hWnd);

			Result = BitBlt(hdcDest, nXDest, nYDest, nWidth, nHeight, hDC, 0, 0, dwRop);

			ReleaseDC(g_hWnd, hDC);

			return Result;
		}
	}

	_asm
	{
		PUSH dwRop
		PUSH nYSrc
		PUSH nXSrc
		PUSH hdcSrc
		PUSH nHeight
		PUSH nWidth
		PUSH nYDest
		PUSH nXDest
		PUSH hdcDest
		MOV ECX, g_pBitBlt
		ADD ECX, 5
		PUSH RetLabel
		PUSH EBP
		MOV EBP, ESP
		JMP ECX						
		RetLabel:
		MOV Result, EAX
	}
}

// qEBhẼtbNvV[W
LRESULT CALLBACK ChildHookProc(HWND hWnd , UINT Msg , WPARAM WParam , LPARAM LParam)
{
	POINT Pos;

	switch (Msg)
	{
		case WM_MOUSEMOVE:
		case WM_LBUTTONDBLCLK:
		case WM_LBUTTONDOWN:
		case WM_LBUTTONUP:
		case WM_MBUTTONDBLCLK:
		case WM_MBUTTONDOWN:
		case WM_MBUTTONUP:
		case WM_RBUTTONDBLCLK:
		case WM_RBUTTONDOWN:
		case WM_RBUTTONUP:
			Pos.x = LParam & 0xFFFF; 
			Pos.y = (LParam & 0xFFFF0000) >> 16; 

			Pos.x = Pos.x * 100 / g_Info.Scale;
			Pos.y = Pos.y * 100 / g_Info.Scale;

			LParam = Pos.x | (Pos.y << 16);
	}

	return CallWindowProc(g_Procs[hWnd] , hWnd, Msg, WParam, LParam);
}

BOOL CALLBACK EnumChildProc(HWND hWnd, LPARAM Param)
{
	WNDPROC p = (WNDPROC)GetWindowLong(hWnd, GWL_WNDPROC);
	SetWindowLong(hWnd, GWL_WNDPROC, (LONG)ChildHookProc);

	g_Procs[hWnd] = p;

	return TRUE;
}


void Init(void)
{
	// LJ
	HANDLE hMap = OpenFileMapping(FILE_MAP_READ, FALSE, "SandBurstShareMemory");
	HOOK_INFO *Info = (HOOK_INFO*)MapViewOfFile(hMap, FILE_MAP_READ, 0, 0, 0x1000);
	if (Info)
	{
		// tbNǂݍ
		memcpy(&g_Info, Info, sizeof(g_Info));	
		UnmapViewOfFile(Info);
		g_hWnd = g_Info.hWnd;
	}
	if (hMap)
	{
		CloseHandle(hMap);
	}

	

	// EBhEvV[WtbN
	if (g_Info.MessageHook)
	{
		OriginalProc = (WNDPROC)GetWindowLong(g_hWnd, GWL_WNDPROC);
		SetWindowLong(g_hWnd, GWL_WNDPROC, (LONG)HookProc);
		EnumChildWindows(g_hWnd , EnumChildProc , 0);
	}
	
	// GetCursorPos tbN
	if (g_Info.GetCursorPosHook)
	{
		g_pGetCursorPos = GetProcAddress(GetModuleHandle("user32.dll"), "GetCursorPos");
		memcpy(g_GetCursorPosCode, g_pGetCursorPos, sizeof(g_GetCursorPosCode));
		Hook(g_pGetCursorPos, HkGetCursorPos);
	}

	// SetCursorPos tbN
	if (g_Info.SetCursorPosHook)
	{
		g_pSetCursorPos = GetProcAddress(GetModuleHandle("user32.dll"), "SetCursorPos");
		memcpy(g_SetCursorPosCode, g_pSetCursorPos, sizeof(g_SetCursorPosCode));
		Hook(g_pSetCursorPos, HkSetCursorPos);
	}

	// ClipCursor tbN
	if (g_Info.ClipCursolHook)
	{
		g_pClipCursor = GetProcAddress(GetModuleHandle("user32.dll"), "ClipCursor");
		memcpy(g_ClipCursorCode, g_pClipCursor, sizeof(g_ClipCursorCode));
		Hook(g_pClipCursor, HkClipCursor);
	}

	// MoveWindow tbN
	if (g_Info.MoveWindowHook)
	{
		g_pMoveWindow = GetProcAddress(GetModuleHandle("user32.dll"), "MoveWindow");
		memcpy(g_MoveWindowCode, g_pMoveWindow, sizeof(g_MoveWindowCode));
		Hook(g_pMoveWindow, HkMoveWindow);
	}

	// SetWindowPos tbN
	if (g_Info.SetWindowPosHook)
	{
		g_pSetWindowPos = GetProcAddress(GetModuleHandle("user32.dll"), "SetWindowPos");
		memcpy(g_SetWindowPosCode, g_pSetWindowPos, sizeof(g_SetWindowPosCode));
		Hook(g_pSetWindowPos, HkSetWindowPos);
	}

	// XN[Vbg̕␳
	if (g_Info.ScreenShotHook)
	{
		// GetDC tbN
		g_pGetDC = GetProcAddress(GetModuleHandle("user32.dll"), "GetDC");
		memcpy(g_GetDCCode, g_pGetDC, sizeof(g_GetDCCode));
		Hook(g_pGetDC, HkGetDC);

		// ReleaseDC tbN
		g_pReleaseDC = GetProcAddress(GetModuleHandle("user32.dll"), "ReleaseDC");
		memcpy(g_ReleaseDCCode, g_pReleaseDC, sizeof(g_ReleaseDCCode));
		Hook(g_pReleaseDC, HkReleaseDC);

		// BitBlt tbN
		g_pBitBlt = GetProcAddress(GetModuleHandle("gdi32.dll"), "BitBlt");
		memcpy(g_BitBltCode, g_pBitBlt, sizeof(g_BitBltCode));
		Hook(g_pBitBlt, HkBitBlt);
	}
}


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	DWORD Write;
	std::map<HWND, WNDPROC>::iterator it;

    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			Init();
			break;

		case DLL_PROCESS_DETACH:
			// N[Abv
			if (OriginalProc)
			{
				SetWindowLong(g_hWnd, GWL_WNDPROC, (LONG)OriginalProc);
				it = g_Procs.begin();
				while (it != g_Procs.end())
				{
					SetWindowLong((*it).first, GWL_WNDPROC, (LONG)(*it).second);
					it++;
				}
			}
			if (g_pGetCursorPos)
				WriteProcessMemory(GetCurrentProcess(), g_pGetCursorPos, g_GetCursorPosCode, sizeof(g_GetCursorPosCode), &Write);
			if (g_pSetCursorPos)
				WriteProcessMemory(GetCurrentProcess(), g_pSetCursorPos, g_SetCursorPosCode, sizeof(g_SetCursorPosCode), &Write);
			if (g_pMoveWindow)
				WriteProcessMemory(GetCurrentProcess(), g_pMoveWindow, g_MoveWindowCode, sizeof(g_MoveWindowCode), &Write);
			if (g_pSetWindowPos)
				WriteProcessMemory(GetCurrentProcess(), g_pSetWindowPos, g_SetWindowPosCode, sizeof(g_SetWindowPosCode), &Write);
			if (g_pClipCursor)
				WriteProcessMemory(GetCurrentProcess(), g_pClipCursor, g_ClipCursorCode, sizeof(g_ClipCursorCode), &Write);
			if (g_pGetDC)
				WriteProcessMemory(GetCurrentProcess(), g_pGetDC, g_GetDCCode, sizeof(g_GetDCCode), &Write);
			if (g_pReleaseDC)
				WriteProcessMemory(GetCurrentProcess(), g_pReleaseDC, g_ReleaseDCCode, sizeof(g_ReleaseDCCode), &Write);
			if (g_pBitBlt)
				WriteProcessMemory(GetCurrentProcess(), g_pBitBlt, g_BitBltCode, sizeof(g_BitBltCode), &Write);

			break;
    }
    return TRUE;
}