unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DwmApi, ExtCtrls, ComCtrls, Menus, Unit2, psapi;

  const HOOK_DLL_NAME = 'SandBurstHook.dll';
type
  THookInfo = Record
    Wnd:                HWND;
    Scale:              Integer;
    ClientSize:         TPoint;
    MessageHook:        LongBool;
    SetCursorPosHook:   LongBool;
    GetCursorPosHook:   LongBool;
    MoveWindowHook:     LongBool;
    SetWindowPosHook:   LongBool;
    ClipCursolHook:     LongBool;
    ScreenShotHook:     LongBool;
  end;
  PHookInfo = ^THookInfo;


  TForm1 = class(TForm)
    Button2: TButton;
    Button3: TButton;
    GroupBox1: TGroupBox;
    Timer1: TTimer;
    Label1: TLabel;
    Button1: TButton;
    TrackBar1: TTrackBar;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    PopupMenu1: TPopupMenu;
    Panel1: TPanel;
    Label2: TLabel;
    CheckBox9: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    FThumbnail: THandle;
    FClientSize: TPoint;
    FWindowSize: TPoint;
    FScaledWindowSize: TPoint;
    FTargetWindow: HWND;
    FSelectWindow: HWND;
    FDLLInjected: Boolean;
    FWindowModified: Boolean;
    FFileMap: THandle;
    FHookInfo: PHookInfo;
    procedure ReleaseThumbnail;
    procedure UpdateWindowPos;
    procedure RestoreWindowSize;
    function DLLInject(Wnd: HWND): Boolean;  // EBhEnhtbNDLL𒍓
    function DLLRelease(Wnd: HWNd): Boolean; // tbNDLL
    procedure PopupMenuClick(Sender: TObject);
  public
    { Public 錾 }
  end;


var
  Form1: TForm1;

implementation


{$R *.dfm}

procedure ShowMsg(Msg: String; Title: String; _Type: Integer);
begin
    MessageBox(GetActiveWindow(), PChar(Msg), PChar(Title), _Type);
end;

function GetDesktopWindows(var Windows: Array of HWND): Integer;
var Wnd: HWND;
    IngStyle: Integer;
    Count: Integer;
    tmp: Array[0..255] of Char;
begin
    Count := 0;

	Wnd := GetWindow(GetDesktopWindow(), GW_CHILD);

	while (Wnd <> 0) do
    begin
	    if (IsWindow(Wnd))  then
		begin
			if (IsWindowVisible(Wnd)) then
            begin
			    IngStyle := GetWindowLong(Wnd, GWL_STYLE);

				if ((IngStyle and WS_CAPTION) = WS_CAPTION) then
                begin
                    Windows[Count] := Wnd;
                    Inc(Count);
				end else
                begin
                    if (GetWindowText(Wnd, tmp, 255) > 0) then
                    begin
                        if (lstrcmp(@tmp, PChar('X^[g')) <> 0)
                          and (lstrcmp(@tmp, PChar('Program Manager')) <> 0) then
                        begin
                            Windows[Count] := Wnd;
                            Inc(Count);

                        end;
                    end;
                end;
			end;
		end;

		Wnd := GetWindow(Wnd, GW_HWNDNEXT);
    end;


    Result := Count;
end;

procedure EnableControl(Control: TWinControl; Enable: Boolean);
var i: Integer;
begin
    if Control = NIL then Exit;
    for i:=0 to Control.ControlCount -1 do begin
        EnableControl( TWinControl(Control.Controls[i]), Enable);
    end;

    Control.Enabled := Enable;
end;

procedure TForm1.ReleaseThumbnail;
begin
    if FThumbnail <> 0 then DwmUnregisterThumbnail(FThumbnail);
    FThumbnail := 0;
end;

procedure TForm1.Button1Click(Sender: TObject);
var i: Integer;
    Text: Array[0..255]of Char;
    WindowCount: Integer;
    Wnds: Array of HWND;
    Item: TMenuItem;
    Pos, WindowSize: TPoint;
    Rc: TRect;
begin
    PopupMenu1.Items.Clear;

    SetLength(Wnds, 1024);
    WindowCount := GetDeskTopWindows(Wnds);



    for i := WindowCount -1 downto 0 do
    begin
        if (Wnds[i] <> Self.Handle) and (Wnds[i] <> Form2.Handle) and (Wnds[i] <> Application.Handle) then
        begin
            Windows.GetWindowRect(Wnds[i], Rc);
            WindowSize.X := Rc.Right - Rc.Left;
            WindowSize.Y := Rc.Bottom - Rc.Top;

            if (WindowSize.X > 0) and (WindowSize.Y > 0) then
            begin
                GetWindowText(Wnds[i], @Text[0], sizeof(Text));
                Item := TMenuItem.Create(Self);
                PopupMenu1.Items.Add(Item);

                Item.Caption := Text;
                Item.Tag := Wnds[i];
                Item.AutoHotkeys := maManual;
                Item.OnClick := PopupMenuClick;
                Item.GroupIndex := 0;
            end;
        end;
    end;


    GetCursorPos(Pos);
    PopupMenu1.Popup(Pos.x, Pos.y);
end;

procedure TForm1.PopupMenuClick(Sender: TObject);
var Item: TMenuItem;
begin
    Item := TMenuItem(Sender);
    FSelectWindow := Item.Tag;

    Label2.Caption := Item.Caption;

    PopupMenu1.Items.Clear;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    RestoreWindowSize;
    ReleaseThumbnail;
    UnmapViewOfFile(FHookInfo);
    CloseHandle(FFileMap);
end;

procedure TForm1.Button2Click(Sender: TObject);
var Prop: DWM_THUMBNAIL_PROPERTIES;
    Scale: Integer;
    Rc, ClientRc: TRect;
    Pos1, Pos2: TPoint;
    Wnd: HWND;
begin
    if FSelectWindow = 0 then Exit;

   

    // Â̂
    if FDLLInjected then DLLRelease(FTargetWindow);

    if FThumbnail <> 0 then ReleaseThumbnail;

    if FTargetWindow <> 0 then RestoreWindowSize;


 
    Wnd := FSelectWindow;

    

    // ŏꂽEBhE͊głȂ
    if GetWindowLong(Wnd, GWL_STYLE) and WS_MINIMIZE <> 0 then
    begin
        ShowMsg('ŏꂽEBhE͊gł܂', 'G[', MB_OK);
        Exit;
    end;

      

    // DWMɃEBhEo^
    if DwmRegisterThumbnail(Form2.Handle, Wnd, @FThumbnail) <> S_OK then
    begin
        ShowMsg('TlC̎擾Ɏs', 'G[', MB_OK);
        FThumbnail := 0;
        Exit;
    end;


    // Ώۂ̃NCAgTCY擾
    Windows.GetClientRect(Wnd, ClientRc);
    FClientSize.X := ClientRc.Right - ClientRc.Left;
    FClientSize.Y := ClientRc.Bottom - ClientRc.Top;

    Pos1 := Point(ClientRc.Left, ClientRc.Top);
    Windows.ClientToScreen(Wnd, Pos1);

    Windows.GetWindowRect(Wnd, Rc);
    Pos2 := Point(Rc.Left, Rc.Top);

    // NCAg̈̊Jnʒu
    Pos2 := Point(Pos1.X - Pos2.X,  Pos1.Y - Pos2.Y);

    // Ώۂ̔NCAg܂ރEBhETCY
    if (Wnd <> FTargetWindow) then
    begin
        FWindowSize := Point(Rc.Right - Rc.Left, Rc.Bottom - Rc.Top);
    end;


    // g嗦
    Scale := TrackBar1.Position;


    // TlC̍XV
    Prop.dwFlags := $0F;
    Prop.rcDestination := Rect(0, 0,  FClientSize.X * Scale div 100, FClientSize.Y * Scale div 100);
    Prop.rcSource := Rect(Pos2.X, Pos2.Y, FClientSize.X + Pos2.X, FClientSize.Y);
    Prop.opacity := $FF;
    Prop.fVisible := True;
    Prop.fSourceClientAreaOnly := False;

    if (DwmUpdateThumbnailProperties(FThumbnail, @Prop) <> S_OK) then
    begin
        ShowMsg('TlC̍XVɎs', 'G[', MB_OK);
    end;

    // tbNݒ
    FHookInfo.Wnd := Wnd;
    FHookInfo.Scale := Scale;
    FHookInfo.ClientSize := FClientSize;
    FHookInfo.MessageHook := CheckBox1.Checked;
    FHookInfo.SetCursorPosHook := CheckBox2.Checked;
    FHookInfo.GetCursorPosHook := CheckBox3.Checked;
    FHookInfo.ClipCursolHook := CheckBox4.Checked;
    FHookInfo.MoveWindowHook := CheckBox5.Checked;
    FHookInfo.SetWindowPosHook := CheckBox6.Checked;
    FHookInfo.ScreenShotHook := CheckBox7.Checked;

    // tbNDLL
    DLLInject(Wnd);

    // g̔N܂ރEBhETCY
    FScaledWindowSize.X := FClientSize.X * Scale div 100 + Rc.Right - Rc.Left - FClientSize.X;
    FScaledWindowSize.Y := FClientSize.Y * Scale div 100 + Rc.Bottom - Rc.Top - FClientSize.Y;
    FWindowModified := CheckBox8.Checked;
    if FWindowModified then
    begin
        Windows.SetWindowPos(Wnd, 0, Rc.Left, Rc.Top, FScaledWindowSize.X, FScaledWindowSize.Y, 0);
    end;

    // Rg[
    //EnableControl(GroupBox1, False); 
    Button2.Enabled := False;
    Button3.Enabled := True;

    // 낢L
    FTargetWindow := Wnd;
    Timer1.Enabled := True;


    // Rs[EBhEXV
    Form2.SetSize(FClientSize.X * Scale div 100, FClientSize.Y * Scale div 100);
    Form2.SetPos(Pos1.X, Pos1.Y);
    Form2.Visible := CheckBox9.Checked;


    // 
    SetForegroundWindow(Wnd);
end;

procedure TForm1.UpdateWindowPos;
var Rc: TRect;
    Pos: TPoint;
begin
    Windows.GetClientRect(FTargetWindow, Rc);
    Pos := Point(Rc.Left, Rc.Top);

    Windows.ClientToScreen(FTargetWindow, Pos);

    Form2.SetPos(Pos.X, Pos.Y);
end;

procedure TForm1.RestoreWindowSize;
var Rc: TRect;
begin
    if FTargetWindow = 0 then Exit;

    GetWindowRect(FTargetWindow, Rc);

    SetWindowPos(FTargetWindow, 0, Rc.Left, Rc.Top, FWindowSize.X, FWindowSize.Y, SWP_NOACTIVATE);

    FWindowModified := False;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
    Label1.Caption := Format('g嗦 -%d', [TrackBar1.Position]) + '%';

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    TrackBar1.Position := 100;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
    TrackBar1.Position := 150;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
    TrackBar1.Position := 200;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
    TrackBar1.Position := 300;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    Form2 := TForm2.Create;

    FFileMap := CreateFileMapping(INVALID_HANDLE_VALUE, NIL, PAGE_READWRITE, 0, $1000, PChar('SandBurstShareMemory'));
    if FFileMap = 0 then
    begin
        ShowMsg('L̍쐬Ɏs܂', 'G[', MB_OK);
        Close;
        Exit;
    end;

    FHookInfo := PHookInfo(MapViewOfFile(FFileMap, FILE_MAP_ALL_ACCESS, 0, 0, $1000));
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    if GetWindowLong(FTargetWindow, GWL_STYLE) and WS_MINIMIZE <> 0 then
    begin
        ShowMsg('EBhEŏԂł͒~ł܂', 'G[', MB_OK);
        Exit;
    end;

    DLLRelease(FTargetWindow);
    ReleaseThumbnail;
    RestoreWindowSize;
    FTargetWindow := HWND(0);
    Timer1.Enabled := False;

    // Rg[L
    //EnableControl(GroupBox1, True);  
    Button2.Enabled := True;
    Button3.Enabled := False;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var Wnd: HWND;
    Rc: TRect;
begin
    Wnd := Windows.GetForegroundWindow;

    if Wnd <> FTargetWindow then
    begin
        if Scaled then
        begin
            Form2.Visible := False;
            RestoreWindowSize;
        end;
    end else
    begin
        if Form2.Visible = False then
        begin
            GetWindowRect(FTargetWindow, Rc);
            if CheckBox8.Checked then
            begin
                Windows.SetWindowPos(Wnd, 0, Rc.Left, Rc.Top, FScaledWindowSize.X, FScaledWindowSize.Y, 0);
                FWindowModified := True;
            end;
            Form2.Visible := CheckBox9.Checked;
        end;

        UpDateWindowPos;
    end;
end;

function TForm1.DLLInject(Wnd: HWND): Boolean;
var ProcessID, Size: DWord;
    Modules: Array[0..255] of HModule;
    hProcess: THandle;
    i: Integer;
    ModulePath: Array[0..259] of Char;
    ModuleName: String;
    pKernel, pKernel2: Pointer;
    Mem: Pointer;
    Write: DWord;
    HookDllName: String;
    pLoadLibrary: Pointer;
    ThreadID: DWord;
    hThread: THandle;
begin
    Result := False;
    GetWindowThreadProcessId(Wnd, ProcessID);

    hProcess := OpenProcess(PROCESS_ALL_ACCESS, FALSE, ProcessID);
    if hProcess = 0 then
    begin
        ShowMsg('vZX̃I[vɎs܂', 'G[', MB_OK);
        Exit;
    end;

    pKernel := NIL;
    if not EnumProcessModules(hProcess, @Modules[0], sizeof(Modules), Size) then
    begin
        ShowMsg('EnumProcessModulesɎs܂', 'G[', MB_OK);
    end;

    for i := 0 to Size div 4 -1 do
    begin
        GetModuleFileNameEx(hProcess, Modules[i], @ModulePath[0], sizeof(ModulePath));

        ModuleName := LowerCase(ExtractFileName(ModulePath));
        if ModuleName = 'kernel32.dll' then
        begin
            pKernel := Pointer(Modules[i]);
            break;
        end;
    end;

    if pKernel = NIL then
    begin
        ShowMsg('kernel32.dll̃AhX̎擾Ɏs܂', 'G[', MB_OK);
        CloseHandle(hProcess);
        Exit;
    end;

    Mem := VirtualAllocEx(hProcess, NIL, $1000, MEM_COMMIT, PAGE_READWRITE);
    if Mem = NIL then
    begin
        ShowMsg('VirtualAllocExɎs܂', 'G[', MB_OK);
        CloseHandle(hProcess);
        Exit;
    end;

    GetModuleFileName(0, @ModulePath[0], sizeof(ModulePath));

    HookDllName := ExtractFileDir(ModulePath) + '\' + HOOK_DLL_NAME;
    if not WriteProcessMemory(hProcess, Mem, PChar(HookDllName), Length(HookDllName)+1, Write) then
    begin
        ShowMsg('WriteProcessMemoryɎs܂', 'G[', MB_OK);
        VirtualFreeEx(hProcess, Mem, $1000, MEM_FREE);
        CloseHandle(hProcess);
        Exit;
    end;

    pKernel2 := Pointer(GetModuleHandle(PChar('kernel32.dll')));

    pLoadLibrary := Pointer( DWORD(  GetProcAddress(HModule(pKernel2), PChar('LoadLibraryA'))  ) - DWORD(pKernel2) + DWORD(pKernel));
    hThread := CreateRemoteThread(hProcess, NIL, 0, pLoadLibrary, Mem, 0, ThreadID);

    if hThread = 0 then
    begin
        ShowMsg('CreateRemoteThreadɎs܂', 'G[', MB_OK);
        VirtualFreeEx(hProcess, Mem, $1000, MEM_FREE);
        CloseHandle(hProcess);
        Exit;
    end;

    WaitForSingleObject(hThread, 3000);
    CloseHandle(hThread);

    VirtualFreeEx(hProcess, Mem, $1000, MEM_FREE);
    CloseHandle(hProcess);

    FDLLInjected := True;
    Result := True;
end;

function TForm1.DLLRelease(Wnd: HWND): Boolean;
var ProcessID, Size: DWord;
    Modules: Array[0..255] of HModule;
    hProcess: THandle;
    i: Integer;
    ModulePath: Array[0..259] of Char;
    ModuleName: String;
    pKernel, pKernel2, pHookDll: Pointer;
    pFreeLibrary: Pointer;
    ThreadID: DWord;
    hThread: THandle;
begin
    Result := False;

    if not FDllInjected then Exit;

    FDLLInjected := False;

    GetWindowThreadProcessId(Wnd, ProcessID);

    hProcess := OpenProcess(PROCESS_ALL_ACCESS, FALSE, ProcessID);
    if hProcess = 0 then
    begin
        // vZXJȂȂĂAɏIƉ肷
        //ShowMsg('vZX̃I[vɎs܂', 'G[', MB_OK);
        Exit;
    end;

    pKernel := NIL;
    pHookDll := NIL;
    EnumProcessModules(hProcess, @Modules[0], sizeof(Modules), Size);

    for i := 0 to Size div 4 -1 do
    begin
        GetModuleFileNameEx(hProcess, Modules[i], @ModulePath[0], sizeof(ModulePath));

        ModuleName := LowerCase(ExtractFileName(ModulePath));
        if ModuleName = 'kernel32.dll' then
        begin
            pKernel := Pointer(Modules[i]);
        end else if ModuleName = 'sandbursthook.dll' then
        begin
            pHookDll := Pointer(Modules[i]);
            if pKernel <> NIL then break;
        end;
    end;

    if pKernel = NIL then
    begin
        ShowMsg('kernel32.dll̃AhX̎擾Ɏs܂', 'G[', MB_OK);
        CloseHandle(hProcess);
        Exit;
    end;

    if pHookDll = NIL then
    begin
        ShowMsg('SandBurstHook.dll̃AhX̎擾Ɏs܂', 'G[', MB_OK);
        CloseHandle(hProcess);
        Exit;
    end;


    pKernel2 := Pointer(GetModuleHandle(PChar('kernel32.dll')));

    pFreeLibrary := Pointer( DWORD(  GetProcAddress(HModule(pKernel2), PChar('FreeLibrary'))  ) - DWORD(pKernel2) + DWORD(pKernel));
    hThread := CreateRemoteThread(hProcess, NIL, 0, pFreeLibrary, pHookDll, 0, ThreadID);

    if hThread = 0 then
    begin
        ShowMsg('CreateRemoteThreadɎs܂', 'G[', MB_OK);
        CloseHandle(hProcess);
        Exit;
    end;

    WaitForSingleObject(hThread, 3000);
    CloseHandle(hThread);
    CloseHandle(hProcess);

    Result := True;
end;

end.


