unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;

type
    TForm2 = Class
    private
        FHandle: HWND;
        FVisible: Boolean;
        FPos: TPoint;
        FSize: TPoint;
        procedure SetVisible(Vis: Boolean);

    public
        property Handle: HWND read FHandle;
        property Visible: Boolean read FVisible write SetVisible;
        Constructor Create;
        procedure SetPos(x: Integer; y: Integer);
        procedure SetSize(sx: Integer; sy: Integer);
    end;

var

    Form2: TForm2;

implementation

function WindowProc(Wnd: HWND; Msg: UINT; WP: WParam; LP: LParam): HResult; stdcall;
begin
    Result := 0;
    case Msg of
        WM_DESTROY:
        begin
            PostQuitMessage(0);
            Exit;
        end;
    end;

    Result := DefWindowProc(Wnd, Msg, WP, LP);
end;

Constructor TForm2.Create;
var wc: WNDCLASSEX;
    exStyle: DWord;
begin
    inherited;
    wc.cbSize        := sizeof(WNDCLASSEX);
	wc.style         := 0;
	wc.lpfnWndProc   := @WindowProc;
	wc.cbClsExtra    := 0;
	wc.cbWndExtra    := 0;
	wc.hInstance     := GetModuleHandle(NIL);
	wc.hIcon         := HICON(0);
	wc.hCursor       := HCURSOR(0);
	wc.hbrBackground := HBRUSH(0);
	wc.lpszMenuName  := NIL;
	wc.lpszClassName := PChar('SundBurst');;
	wc.hIconSm       := HICON(0);

    FSize := Point(1,1);
    RegisterClassEx(wc);

    exStyle := WS_EX_TOPMOST or WS_EX_LAYERED or WS_EX_TRANSPARENT;

    FHandle := CreateWindowEx(exStyle, PChar('SundBurst'), 'SundBurst', 0, 0, 0, 1, 1, HWND(0), HMENU(0), GetModuleHandle(NIL), NIL);
end;

procedure TForm2.SetVisible(Vis: Boolean);
begin
    if Vis then
        ShowWindow(FHandle, SW_SHOWNORMAL)
    else
        ShowWindow(FHandle, SW_HIDE);

    FVisible := Vis;
end;

procedure TForm2.SetPos(x: Integer; y: Integer);
begin
    SetWindowPos(FHandle, 0, x, y, FSize.X, FSize.Y, 0);
    FPos.X := x;
    FPos.Y := y;
end;

procedure TForm2.SetSize(sx: Integer; sy: Integer);
begin
    SetWindowPos(FHandle, 0, FPos.X, FPos.Y, sx, sy, 0);
    FSize.X := sx;
    FSize.Y := sy;
end;

end.
 